# Copyright 2017 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by puppet-codegen and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'puppet/property'

module Google
  module Container
    module Data
      # A class to manage data for management for node_pool.
      class NodePoolManagem
        include Comparable

        attr_reader :auto_upgrade
        attr_reader :auto_repair
        attr_reader :upgrade_options

        def to_json(_arg = nil)
          {
            'autoUpgrade' => auto_upgrade,
            'autoRepair' => auto_repair,
            'upgradeOptions' => upgrade_options
          }.reject { |_k, v| v.nil? }.to_json
        end

        def to_s
          {
            auto_upgrade: auto_upgrade,
            auto_repair: auto_repair,
            upgrade_options: upgrade_options
          }.reject { |_k, v| v.nil? }.map { |k, v| "#{k}: #{v}" }.join(', ')
        end

        def ==(other)
          return false unless other.is_a? NodePoolManagem
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            return false if compare[:self] != compare[:other]
          end
          true
        end

        def <=>(other)
          return false unless other.is_a? NodePoolManagem
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            result = compare[:self] <=> compare[:other]
            return result unless result.zero?
          end
          0
        end

        private

        def compare_fields(other)
          [
            { self: auto_upgrade, other: other.auto_upgrade },
            { self: auto_repair, other: other.auto_repair },
            { self: upgrade_options, other: other.upgrade_options }
          ]
        end
      end

      # Manages a NodePoolManagem nested object
      # Data is coming from the GCP API
      class NodePoolManagemApi < NodePoolManagem
        def initialize(args)
          @auto_upgrade =
            Google::Container::Property::Boolean.api_munge(args['autoUpgrade'])
          @auto_repair =
            Google::Container::Property::Boolean.api_munge(args['autoRepair'])
          @upgrade_options =
            Google::Container::Property::NodePoolUpgraOptio.api_munge(
              args['upgradeOptions']
            )
        end
      end

      # Manages a NodePoolManagem nested object
      # Data is coming from the Puppet manifest
      class NodePoolManagemCatalog < NodePoolManagem
        def initialize(args)
          @auto_upgrade = Google::Container::Property::Boolean.unsafe_munge(
            args['auto_upgrade']
          )
          @auto_repair = Google::Container::Property::Boolean.unsafe_munge(
            args['auto_repair']
          )
          @upgrade_options =
            Google::Container::Property::NodePoolUpgraOptio.unsafe_munge(
              args['upgrade_options']
            )
        end
      end
    end

    module Property
      # A class to manage input to management for node_pool.
      class NodePoolManagem < Puppet::Property
        # Used for parsing Puppet catalog
        def unsafe_munge(value)
          self.class.unsafe_munge(value)
        end

        # Used for parsing Puppet catalog
        def self.unsafe_munge(value)
          return if value.nil?
          Data::NodePoolManagemCatalog.new(value)
        end

        # Used for parsing GCP API responses
        def self.api_munge(value)
          return if value.nil?
          Data::NodePoolManagemApi.new(value)
        end
      end
    end
  end
end
